import logging
import pytz

from flask import Flask, render_template, request, jsonify, g
from flask_socketio import SocketIO
from flask_socketio import emit
from lesedi.sdk.guider import Guider

HOST="10.2.2.31"

class GuiderApp(object):
    def __init__(self, app=None):
        if app is not None:
            self.init_app(app)

    def init_app(self, app):
        self.app = app
        # self._guider = Guider(test=True, host=HOST)
        self._guider = Guider(test=False, host=HOST)
        self._guider.connect()

    @property
    def guider(self):
        return self._guider

    @property
    def state(self):
        if not hasattr(g, '_state'):
            g._state = self.guider.get_state()
        return g._state


    def set_initialised(self, val):
        self.guider.initialise_slide()
    initialised = property(None, set_initialised)

    def set_RESET(self, val):
        self.guider.reset_slide()
    RESET = property(None, set_RESET)

    
#    def set_reset_slide(self):
#        self.guider.reset_slide()
#    reset = property(None, set_reset_slide)

    def set_STOPsld(self, val):
        self.guider.stop_slide()
    STOPsld = property(None, set_STOPsld)

    def set_goto_x_coord(self, goto_x_coord):
        print("GuiderApp:  Setting X_coord to ", goto_x_coord)
        self.guider.set_goto_x_coord(goto_x_coord)
    goto_x_coord = property(None, set_goto_x_coord)

    def set_goto_y_coord(self, goto_y_coord):
        print("GuiderApp:  Setting Y_coord to ", goto_y_coord)
        self.guider.set_goto_y_coord(goto_y_coord)
    goto_y_coord = property(None, set_goto_y_coord)
        
    def set_gotoXYcoords(self, gotoXYcoords):
        print("GuiderApp:  In set_gotoXY_input ")
        self.guider.set_gotoXYcoords(gotoXYcoords)
    gotoXYcoords = property(None, set_gotoXYcoords)

    
    def set_slide(self, slide_num):
        self.guider.set_slide(slide_num)
    slide = property(None, set_slide)

    def set_guide_coords(self, guide_coords):
        print("Setting chosen guide coords")
        self.guider.set_guide_coords(guide_coords)
    guide_coords = property(None, set_guide_coords)

    def set_GUIDE(self, val):
        self.guider.guide()
    GUIDE = property(None, set_GUIDE)

    def set_faking(self):
        self.guider.fake()
    faking = property(None, set_faking)

#    def set_binning(self, binfact):
#        self.guider.set_binning(binfact)
#    binning = property(None, set_binning)


    def set_binning(self, binning):
        self.guider.set_binning(binning)
    binning = property(None, set_binning)
        
    def set_exposure_time(self, exposure_time):
        print("GuiderApp:  Setting exposure time to ", exposure_time)
        self.guider.set_exposure_time(exposure_time)
    exposure_time = property(None, set_exposure_time)

    def set_start_exposures(self, val):
        print("Guider: Taking continuous exposures")
        self.guider.start_exposures(continuous=True)
    start_exposures = property(None, set_start_exposures)

    def set_stopping(self, val):
        print("GuiderApp: Stopping exposures")
        self.guider.stop_exposures()
    stopping = property(None, set_stopping)

    def set_oneshot(self, val):
        print("Guider: Taking a single exposure")
        self.guider.start_exposures(continuous=False)
    oneshot = property(None, set_oneshot)

socketio = SocketIO(async_mode='eventlet', binary=True)
guider = GuiderApp()


def create_app():
    app = Flask(__name__)
    print("In create_app")
    app.config.from_pyfile('settings.py')

    app.timezone = pytz.timezone(app.config['TIME_ZONE'])

    logger = logging.getLogger('werkzeug')
    logger.setLevel(logging.ERROR)

    # portal.init_app(app)
    print("Calling init_app for socket")
    socketio.init_app(app)
    print("Calling init_app for guider")
    guider.init_app(app)

    # assets.register('js', Bundle(
    #     'filament/js/filament.js',
    #     'src/js/app.js',
    #     'src/js/d3.js',
    #     output='js/app.js'
    # ))

    # assets.register('css', Bundle(
    #     'filament/css/filament.css',
    #     'src/css/app.css',
    #     'src/css/js9.css',
    #     'src/css/js9support.css',
    #     output='css/app.css'
    # ))

    from app import views
    app.register_blueprint(views.main)
    app.register_blueprint(views.api, url_prefix='/api')

    return app
    

