
from flask_wtf import FlaskForm
from wtforms import TextField, SelectField, IntegerField, FloatField, FormField
import lesedi.sdk.guider


BINNING_NONE = 1
BINNING_CHOICES = [
    (0, '1x1'),
    (1, '2x2'),
]

SLIDE_NONE = 2
SLIDE_CHOICES = [
    (0, 'Slide 0'),
    (1, 'Slide 1'),
    (2, 'Slide Select'),
]

class Form(FlaskForm):

    exposure_time = FloatField('ExposureY time')
    goto_x_coord = IntegerField('goto_x_coord', default = 0)
    goto_y_coord = IntegerField('goto_y_coord', default = 0)
    goto_xGS = IntegerField('goto_xGS', default = 0)
    goto_yGS = IntegerField('goto_yGS', default = 0)
    goto_RA_coord = IntegerField('goto_RA_coord', default = 0)
    goto_Dec_coord = FloatField('goto_Dec_coord', default = 0)

    binning = SelectField('Binning',
                          choices=BINNING_CHOICES,
                          coerce=int)
    
    slides = SelectField('Slides', choices=SLIDE_CHOICES, default=SLIDE_NONE, coerce=int)

    slide_moving = FloatField('slide_moving', default=0.0)
    slide_init = FloatField('slide_init', default=0.0)
    slide_x = FloatField('slide_x', default=0.0)
    slide_y = FloatField('slide_y', default=0.0)

#    no_lodestars = FloatField('no_lodestars', default=0)
    
    exit_continuous = FloatField('ext_continuous', default=0.0)

    slide_initialised = TextField('slide_init', default="Not initialised")
    
    click_xc0 = FloatField('Chosen guide position x', default=0.0)
    click_yc0 = FloatField('Chosen guide position y', default=0.0)

    xc = FloatField('Guide star position x', default=0.0)
    yc = FloatField('Guide star position y', default=0.0)
    
