var APP = {};

var global_xc = 0; // make these 20 so that they are not on edge of image on startup
var global_yc = 0;
var global_xc0 = 0;
var global_yc0 = 0;

Backbone.Model.prototype.patch = function(data) {
    APP.alert.hide();
    return this.save(data, {patch: true, wait: true});
};

APP.Alert = Backbone.View.extend({
    el: '#alert',

    events: {
        'click .close': 'hide'
    },

    hide: function() {
        this.$el.addClass('d-none');
    },

    render: function(type, message) {
        this.$el.removeClass('d-none alert-danger alert-success alert-warning alert-info')
            .addClass(type)
            .find('.alert-body')
            .html(message);
    }
});

APP.Mixins = {
    Poller: {
        poll: function(countdown) {
            var fetch = _.bind(this.poll, this);

            this.fetch({
                retry: true,
                timeout: 10000,
                error: function(model, response, options) {
                    if (countdown > 0) {
                        console.debug('Retrying', countdown);
			document.getElementById("OnOffLine").style.backgroundColor = "red";
			document.getElementById("OnOffLine").innerHTML = "Connection lost. Please reload the page.";
                        setTimeout(_.partial(fetch, --countdown), 1000);
                    } else {
                        $('span.status').fadeOut();
                        APP.alert.render('alert-danger',
                            'Connection lost: <a href="#" onclick="window.location.reload(); return false;" class="alert-link">Reload the page</a> to try again.');
                    }
                },
                success: function(model) {
//		    var d = new Date();
//		    var n = d.toLocaleTimeString();
                    setTimeout(_.partial(fetch, 5), 1000); // This is the poll rate for status
//                    msg = model.get("message");
		    msg = model.get("skyangle1");
                    console.log("Poll returned success. Message = " + msg);
                    var pos = msg.indexOf("Error getting state");
                    console.log("POS = " + pos);
                    if (pos > -1)
                    {
                        console.log("Error getting state");
			document.getElementById("OnOffLine").style.backgroundColor = "red";
			document.getElementById("OnOffLine").innerHTML = "Webserver unable to fetch state from back-end";
                    }
                    else
                    {
		        document.getElementById("OnOffLine").style.backgroundColor = "green";
		        document.getElementById("OnOffLine").innerHTML = "Online";
                    }

                }
            });
        }
    }
};

jQuery(function($) {
    APP.alert = new APP.Alert();

    //$('[data-toggle="popover"]').popover();

    // Global error handler for ajax requests.
    $(document).ajaxError(function(e, xhr, options) {
        if (xhr.responseJSON && xhr.responseJSON.debug) {
            var message = '<div style="white-space: pre-wrap;">' +
                xhr.responseJSON.debug.replace(/\n/g, "\n") + '</div>';
            APP.alert.render('alert-danger', message);
        }
    });
});

APP.GUIDER = {};

APP.GUIDER.Model = Backbone.Model.extend(_.extend({}, APP.Mixins.Poller, {
    url: '/api/guider',

    defaults: {
        id: 1 // There is only one GUIDER 'model' so we hardcode the ID property.
    }
}));


APP.GUIDER.ControlView = Backbone.View.extend({
    el: '#guider',

    events: {
        'click .btn-initialise': 'initialiseSlides',
	'click .btn-reset': 'RESETSlide',
	'click .btn-stopslide': 'STOPSlide',
        'click .btn-data': 'getImageData',
	'click #canvas': 'recordSelection', // clicking on the live canvas image
	'click #FCdisp': 'recordSelectionFC', // clicking on the DSS image
        'click .btn-select_guide_star': 'sendCoords',
        'click .btn-start-oneshot': 'start_oneshot',
        'click .btn-start': 'start_continuous',
        'click .btn-stop': 'stop_continuous',
	'click .btn-gotoXYinput': 'gotoXY_input',
	'click .btn-gotoXYGS': 'gotoXYGS',
	'click .btn-getFCimage': 'getFCimage',
	'click .btn-guide': 'guideOnOff', 
        'change #exposure_time': 'changeExposureTime',
	'change #goto_x_coord': 'changegoto_x_coord',
	'change #goto_y_coord': 'changegoto_y_coord',
        'change #binning': 'changeBinning', //cannot use binning???
        'change #slides': 'changeSlide',
        'change #click_xc0': 'changeXc0', //cannot use xc0??
        'change #click_yc0': 'changeYc0', //cannot use yc0??
//	'change #yc0': 'change',
//        'click #imagedisp': 'recordSelection', // clicking on the live image
    },

    changeXc0: function(e) {
        var click_xc0 = parseFloat(e.target.value, 0);
        console.log("Xc0 change event. New click_xc0: " + click_xc0);
        if (isNaN(click_xc0)) {
            e.target.value = this.model.get('xc0');
        } else {
            this.model.patch({
                click_xc0: click_xc0
            }).done(function() {
                // When setting the xc0, the detector might revert it
                // back to the minimum if it's less than that. Update the field
                // to reflect the change when that happens.   ???????
//                if (this.model.get('xc0') !== xc0) {
//                    e.target.value = this.model.get('xc0');
//                }
            }.bind(this));
        }
    },


    changeYc0: function(e) {
        var yc0 = parseFloat(e.target.value, 0);
        console.log("Yc0 change event. New click_yc0: " + click_yc0);
        if (isNaN(yc0)) {
            e.target.value = this.model.get('yc0');
        } else {
            this.model.patch({
                click_yc0: click_yc0
            }).done(function() {
                // When setting the yc0, the detector might revert it
                // back to the minimum if it's less than that. Update the field
                // to reflect the change when that happens.
//                if (this.model.get('yc0') !== yc0) { ?????
//                    e.target.value = this.model.get('yc0');
//                }
            }.bind(this));
        }
    },


    changeExposureTime: function(e) {
        var exposureTime = parseFloat(e.target.value, 1000);
        console.log("Exposure time change event. New exposure time: " + exposureTime);
        if (isNaN(exposureTime)) {
            e.target.value = this.model.get('exposure_time');
        } else {
            this.model.patch({
                exposure_time: exposureTime
            }).done(function() {
                // When setting the exposure time, the detector might revert it
                // back to the minimum if it's less than that. Update the field
                // to reflect the change when that happens.
                // if (this.model.get('exposure_time') !== exposureTime) {
                //    e.target.value = this.model.get('exposure_time');
                //}
            }.bind(this));
        }
    },


    changeBinning: function(e) {
        var selectedBinning = parseInt(e.target.value, 0);

        console.log("Binning change event. New binning = " + selectedBinning);
        if (isNaN(selectedBinning)) {
            e.target.value = this.model.get('binning');
        } else {
            this.model.patch({
                binning: selectedBinning
            }).done(function() {
            }.bind(this));
        }
    },

    
    changeSlide: function(e) {
        var selectedSlide = parseInt(e.target.value, 0);

        console.log("Slide change event. New slide = " + selectedSlide);
        if (isNaN(selectedSlide)) {
            e.target.value = this.model.get('which_slide');
        } else {
            this.model.patch({
                slide: selectedSlide
            }).done(function() {
            }.bind(this));
        }
    },

    recordSelection: function(e) {
        console.log("Image clicked");
        const height = 582
        var xCoordinate = event.offsetX;
        var yCoordinate = height - event.offsetY - 1;
        console.log("Clicked X = " + xCoordinate);
        console.log("Clicked Y = " + yCoordinate);
        $('#click_xc0').val(Math.round(xCoordinate)); //
        $('#click_yc0').val(Math.round((height-yCoordinate))); // invert Y to put same way as backend code
    },        

//    x_cam = 1.23*(x_guider_factor - (x_n * x_guider_factor)) -2782
//    y_cam = 0.795*(y_guider_factor - (y_n * y_guider_factor)) + 4252
    recordSelectionFC: function(e) {
        console.log("FC Image clicked");
	var x_guider_factor   = 20000 ;
	var y_guider_factor   = 15000 * 2 ;
        var xCoordinate = event.offsetX;
        var yCoordinate = event.offsetY;

	var skyangle_0 = parseFloat(this.model.get('skyangle0')) ;
	var skyangle_1 = parseFloat(this.model.get('skyangle1')) ;


	console.log("Clicked X = " + xCoordinate);
        console.log("Clicked Y = " + yCoordinate);
	// NOTE this only works (and puts Xy values in GOTO GS field) when on target because skyangle will only be ~0 or ~180 then
	if ( (parseInt(this.model.get('which_slide')) == 0) && (((skyangle_0 >= 0) && (skyangle_0 <= 5)) || ((skyangle_0 >= 355) && (skyangle_0 <= 360))) ) { // slide0 and skyang ~=0
	    $('#goto_xGS').val(Math.round(-29.96*(xCoordinate) + 21364)); 
            $('#goto_yGS').val(Math.round(31.0*  (yCoordinate) + 3756 ));
	} else if ( (parseInt(this.model.get('which_slide')) == 0) && ( ((skyangle_0 <= 0) && (skyangle_0 >= -5))) ) { // slide0 and skyang ~=0 ... seems skyang can be <0
	    $('#goto_xGS').val(Math.round(-29.96*(xCoordinate) + 21364)); 
            $('#goto_yGS').val(Math.round(31.0*  (yCoordinate) + 3756 ));
	} else if ( (parseInt(this.model.get('which_slide')) == 0) && (((skyangle_0 >= 178) && (skyangle_0 <= 182))) ) { // slide0 and skyang ~=180
	    $('#goto_xGS').val(Math.round(30.2*(xCoordinate) - 2082)); 
            $('#goto_yGS').val(Math.round(-29.2*  (yCoordinate) + 14810 ));
	} else if ( (parseInt(this.model.get('which_slide')) == 1) && (((skyangle_1 >= 178) && (skyangle_1 <= 182))) ) { // slide1 and skyang ~=180
	    $('#goto_xGS').val(Math.round(30.2*(xCoordinate) - 2082)); 
            $('#goto_yGS').val(Math.round(-29.2*  (yCoordinate) + 14810 ));
	} else if ( (parseInt(this.model.get('which_slide')) == 1) && (((skyangle_1 >= 0) && (skyangle_1 <= 5)) || ((skyangle_1 >= 355) && (skyangle_1 <= 360))) ) { // slide1 and skyang ~=0      
	    $('#goto_xGS').val(Math.round(-30.0*(xCoordinate) + 21552)); 
            $('#goto_yGS').val(Math.round(32.3*  (yCoordinate) + 3245 ));
	} else if ( (parseInt(this.model.get('which_slide')) == 1) && ( ((skyangle_1 <= 0) && (skyangle_1 >= -5))) ) { // slide1 and skyang ~=0      ... seems skyang can be <0
	    $('#goto_xGS').val(Math.round(-30.0*(xCoordinate) + 21552)); 
            $('#goto_yGS').val(Math.round(32.3*  (yCoordinate) + 3245 ));
	}
    },        
    

    sendCoords: function(event) {
        console.log("Select guide star clicked");
        var click_xc0 = $('#click_xc0').val();
        var click_yc0 = $('#click_yc0').val();
        console.log("Sending " + click_xc0 + " and " + click_yc0);
        this.model.patch(
            {
		guide_coords: [click_xc0, click_yc0]
		//                guide_coords: true
            }).done(function() {
		console.log("Done sending click location");
            }.bind(this));

    },


    guideOnOff: function(e) {
        console.log("guideOnOff");
        this.model.save({GUIDE: true}, {
            wait: true,
            patch: true
        }).catch(function(e) {
            alert('Unable to guideOnOff.');
        });
        console.log("Done guideOnOff");
    },


    
    getImageData: function() {
        APP.guider.socket.emit('data');
        console.log('Emitted data request');
    },
    

    initialiseSlides: function(e) {
        console.log("Initialising slide");
        this.model.save({initialised: true}, {
            wait: true,
            patch: true
        }).catch(function(e) {
            alert('Unable to initialise x/y slide.');
        });
        console.log("Done initialising slide");
    },

    RESETSlide: function(e) {
        console.log("RESET slide");
        this.model.save({RESET: true}, {
            wait: true,
            patch: true
        }).catch(function(e) {
            alert('Unable to RESET x/y slide.');
        });
        console.log("Done RESET slide");
    },

    STOPSlide: function(e) {
        console.log("STOP slide");
        this.model.save({STOPsld: true}, {
            wait: true,
            patch: true
        }).catch(function(e) {
            alert('Unable to STOP x/y slide.');
        });
        console.log("Done STOP slide");
    },



    changegoto_x_coord: function(e) {
        X_coord = parseInt(e.target.value, 10);
        console.log("X_coord change event: " + X_coord);
        if (isNaN(X_coord)) {
            e.target.value = this.model.get('X_coord');
        } else {
            this.model.patch({
                goto_x_coord: goto_x_coord
            }).done(function() {
            }.bind(this));
        }
    },

    changegoto_y_coord: function(e) {
        Y_coord = parseInt(e.target.value, 10);
        console.log("Y_coord change event: " + Y_coord);
        if (isNaN(Y_coord)) {
            e.target.value = this.model.get('Y_coord');
        } else {
            this.model.patch({
                goto_y_coord: goto_y_coord
            }).done(function() {
            }.bind(this));
        }
    },


    
    gotoXY_input: function(e) {
	var goto_x_coord  = $('#goto_x_coord').val();
	var goto_y_coord  = $('#goto_y_coord').val();
	console.log("gotoXY" + goto_x_coord);
        this.model.patch({
	    gotoXYcoords: [goto_x_coord, goto_y_coord]
        }).catch(function(e) {
            alert('Unable to gotoXY');
        });
        console.log("Done gotoXY");
    },

    gotoXYGS: function(e) {
	var goto_x_coord  = $('#goto_xGS').val();
	var goto_y_coord  = $('#goto_yGS').val();
	console.log("gotoXYGS" + goto_x_coord);
        this.model.patch({
	    gotoXYcoords: [goto_x_coord, goto_y_coord]
        }).catch(function(e) {
            alert('Unable to gotoXYGS');
        });
        console.log("Done gotoXYGS");
    },


    // lots of code in order to add or subtract 10 arc minutes of Dec from input RA, Dec AND retrive correct DSS image for rotator AND skyang
    getFCimage: function(e) {
	var goto_RA_coord  = $('#goto_RA_coord').val(); // probably easier and neater to have RA and Dec as one entry field and therefore string
	var goto_Dec_coord  = $('#goto_Dec_coord').val();
	console.log("getFCimage" + goto_Dec_coord);
	var RA_split  = goto_RA_coord.split(" "); //RA_split is an array of RA split by spaces
	var Dec_split = goto_Dec_coord.split(" "); //Dec_split is an array of Dec split by spaces

	var skyangle_0 = parseFloat(this.model.get('skyangle0')) ;
	var skyangle_1 = parseFloat(this.model.get('skyangle1')) ;

	
	if ( (parseInt(this.model.get('which_slide')) == 0) && (((skyangle_0 >= 0) && (skyangle_0 <= 5)) || ((skyangle_0 >= 355) && (skyangle_0 <= 360))) ) { // slide0 and skyang ~=0
	    console.log("getFCimage skyangle_0 " + skyangle_0);
	    // need to add +10arc mins (go North) to Dec because XY slides have accesss to upper half of fov
	    // for negative decs
	    if ( (Dec_split[0].search("-")) >= 0) { // positve numbers will not have a "-" and will return a -1
		var tempDecMins = parseInt(Dec_split[1]) // convert dec mins to integter
		var tempDecDegs = parseInt(Dec_split[0]) // convert dec degs to integter
		if (tempDecMins >= 10){ // if DecMins bigger than 10 then simply subtract 10 (go North)
		    tempDecMins = tempDecMins - 10;
		    Dec_split[1] = tempDecMins.toString() ;
		} else if (tempDecMins < 10) { // for cases that decmins is between 0-10 need to add 1 degree to decDegs
		    if (tempDecDegs < -1){ // add 1 degree to dec for decs more negative than -1
			tempDecDegs =  tempDecDegs + 1;
			Dec_split[0] = tempDecDegs.toString() ;
			tempDecMins = 50 + tempDecMins;
			Dec_split[1] = tempDecMins.toString() ; // convert back to string
		    } else if (tempDecDegs == -1) { // cases when dec between negative 1 and 0
			Dec_split[0] = "-00" ;
			tempDecMins = 50 + tempDecMins;
			Dec_split[1] = tempDecMins.toString() ; // convert back to string
		    } else if (tempDecDegs > -1) { // cases when dec is -00
			Dec_split[0] = "00" ;
			tempDecMins = 10 - tempDecMins;
			Dec_split[1] = tempDecMins.toString() ; // convert back to string
		    }
		}
	    } else { // dec is positive
		var tempDecMins = parseInt(Dec_split[1]) // convert dec mins to integter
		var tempDecDegs = parseInt(Dec_split[0]) // convert dec degs to integter
		if (tempDecMins < 50){ // if DecMins smaller than 50 then simply add 10 (go North)
		    tempDecMins = tempDecMins + 10;
		    Dec_split[1] = tempDecMins.toString() ;
		} else if (tempDecMins >= 50){
		    tempDecMins = tempDecMins -50;
		    Dec_split[1] = tempDecMins.toString() ;
		    tempDecDegs = tempDecDegs + 1;
		    Dec_split[0] = tempDecDegs.toString() ;
		}
		
	    }
	}


	if ( (parseInt(this.model.get('which_slide')) == 0) && (((skyangle_0 >= 178) && (skyangle_0 <= 182))) ) { // slide0 and skyang ~=180
	    console.log("getFCimage skyangle_0 " + skyangle_0);

	    // need to subtract 10arc mins (go South) to Dec because XY slides have accesss to lower half of fov
	    // for negative decs
	    if ( (Dec_split[0].search("-")) >= 0) { // positve numbers will not have a "-" and will return a -1
		var tempDecMins = parseInt(Dec_split[1]) // convert dec mins to integter
		var tempDecDegs = parseInt(Dec_split[0]) // convert dec degs to integter
		if (tempDecMins <= 49){ // if DecMins smaller= than 49 then simply add 10 to minutes (ie go South)
		    tempDecMins = tempDecMins + 10;
		    Dec_split[1] = tempDecMins.toString() ; // convert back to string
		} else if (tempDecMins >= 50) { // for cases that decmins is between 50-59 need to add 1 degree to decDegs
			tempDecDegs =  tempDecDegs - 1;
			Dec_split[0] = tempDecDegs.toString() ;
			tempDecMins = tempDecMins - 50;
			Dec_split[1] = tempDecMins.toString() ; // convert back to string
		}
	    } else { // dec is positive
		var tempDecMins = parseInt(Dec_split[1]) // convert dec mins to integter
		var tempDecDegs = parseInt(Dec_split[0]) // convert dec degs to integter
		if (tempDecMins >= 10){ // if DecMins smaller than 50 then simply add 10 (go North)
		    tempDecMins = tempDecMins - 10;
		    Dec_split[1] = tempDecMins.toString() ;
		} else if (tempDecMins < 10){ 
		    tempDecMins = 50 + tempDecMins;
		    Dec_split[1] = tempDecMins.toString() ;
		    if (tempDecDegs == 0) { // cases when dec is 00
			//tempDecDegs = tempDecDegs ;
			Dec_split[0] = "-00" ; //tempDecDegs.toString() ;
		    } else {
			tempDecDegs = tempDecDegs - 1;
			Dec_split[0] = tempDecDegs.toString() ;
		    }
		}
		
	    }

	} 


	
	if ( (parseInt(this.model.get('which_slide')) == 1) && (((skyangle_1 >= 178) && (skyangle_1 <= 182))) ) { // slide1 and skyang ~=180
	    console.log("getFCimage skyangle_1 " + skyangle_1);

	    // need to subtract 10arc mins (go South) to Dec because XY slides have accesss to lower half of fov
	    // for negative decs
	    if ( (Dec_split[0].search("-")) >= 0) { // positve numbers will not have a "-" and will return a -1
		var tempDecMins = parseInt(Dec_split[1]) // convert dec mins to integter
		var tempDecDegs = parseInt(Dec_split[0]) // convert dec degs to integter
		if (tempDecMins <= 49){ // if DecMins smaller= than 49 then simply add 10 to minutes (ie go South)
		    tempDecMins = tempDecMins + 10;
		    Dec_split[1] = tempDecMins.toString() ; // convert back to string
		} else if (tempDecMins >= 50) { // for cases that decmins is between 50-59 need to add 1 degree to decDegs
			tempDecDegs =  tempDecDegs - 1;
			Dec_split[0] = tempDecDegs.toString() ;
			tempDecMins = tempDecMins - 50;
			Dec_split[1] = tempDecMins.toString() ; // convert back to string
		}
	    } else { // dec is positive
		var tempDecMins = parseInt(Dec_split[1]) // convert dec mins to integter
		var tempDecDegs = parseInt(Dec_split[0]) // convert dec degs to integter
		if (tempDecMins >= 10){ // if DecMins smaller than 50 then simply add 10 (go North)
		    tempDecMins = tempDecMins - 10;
		    Dec_split[1] = tempDecMins.toString() ;
		} else if (tempDecMins < 10){ 
		    tempDecMins = 50 + tempDecMins;
		    Dec_split[1] = tempDecMins.toString() ;
		    if (tempDecDegs == 0) { // cases when dec is 00
			//tempDecDegs = tempDecDegs ;
			Dec_split[0] = "-00" ; //tempDecDegs.toString() ;
		    } else {
			tempDecDegs = tempDecDegs - 1;
			Dec_split[0] = tempDecDegs.toString() ;
		    }
		}
		
	    }

	} 



	if ( (parseInt(this.model.get('which_slide')) == 1) && (((skyangle_1 >= 0) && (skyangle_1 <= 5)) || ((skyangle_1 >= 355) && (skyangle_1 <= 360))) ) { // slide1 and skyang ~=0
	    console.log("getFCimage skyangle_1 " + skyangle_1);
	    // need to add +10arc mins (go North) to Dec because XY slides have accesss to upper half of fov ... I think this same as slide0 and skyang~=0
	    // for negative decs
	    if ( (Dec_split[0].search("-")) >= 0) { // positve numbers will not have a "-" and will return a -1
		var tempDecMins = parseInt(Dec_split[1]) // convert dec mins to integter
		var tempDecDegs = parseInt(Dec_split[0]) // convert dec degs to integter
		if (tempDecMins >= 10){ // if DecMins bigger than 10 then simply subtract 10 (go North)
		    tempDecMins = tempDecMins - 10;
		    Dec_split[1] = tempDecMins.toString() ;
		} else if (tempDecMins < 10) { // for cases that decmins is between 0-10 need to add 1 degree to decDegs
		    if (tempDecDegs < -1){ // add 1 degree to dec for decs more negative than -1
			tempDecDegs =  tempDecDegs + 1;
			Dec_split[0] = tempDecDegs.toString() ;
			tempDecMins = 50 + tempDecMins;
			Dec_split[1] = tempDecMins.toString() ; // convert back to string
		    } else if (tempDecDegs == -1) { // cases when dec between negative 1 and 0
			Dec_split[0] = "-00" ;
			tempDecMins = 50 + tempDecMins;
			Dec_split[1] = tempDecMins.toString() ; // convert back to string
		    } else if (tempDecDegs > -1) { // cases when dec is -00
			Dec_split[0] = "00" ;
			tempDecMins = 10 - tempDecMins;
			Dec_split[1] = tempDecMins.toString() ; // convert back to string
		    }
		}
	    } else { // dec is positive
		var tempDecMins = parseInt(Dec_split[1]) // convert dec mins to integter
		var tempDecDegs = parseInt(Dec_split[0]) // convert dec degs to integter
		if (tempDecMins < 50){ // if DecMins smaller than 50 then simply add 10 (go North)
		    tempDecMins = tempDecMins + 10;
		    Dec_split[1] = tempDecMins.toString() ;
		} else if (tempDecMins >= 50){
		    tempDecMins = tempDecMins -50;
		    Dec_split[1] = tempDecMins.toString() ;
		    tempDecDegs = tempDecDegs + 1;
		    Dec_split[0] = tempDecDegs.toString() ;
		}
		
	    }


	}



	
	var template = "https://archive.stsci.edu/cgi-bin/dss_search?v=poss2ukstu_red&r=HH+MM+SS&d=DDD+DM+DS&e=J2000&h=20.0&w=40.0&f=gif&c=none&fov=NONE&v3=";
	var template1 = template.replace("HH",RA_split[0]);
	var template2 = template1.replace("MM",RA_split[1]);
	var template3 = template2.replace("SS",RA_split[2]);
	var template4 = template3.replace("DDD",Dec_split[0]);
	var template5 = template4.replace("DM",Dec_split[1]);
	var newimage =  template5.replace("DS",Dec_split[2]);
	document.getElementById("FCdisp").src = newimage; // send request to DSS server for new image .... may take a minute or two but doe not hang code
        console.log("Done getFCimage " + Dec_split[0] + " " + Dec_split[1] + " " +  Dec_split[2]);
	console.log("Done getFCimage " + newimage);
    },
    

//	var newimage = "https://archive.stsci.edu/cgi-bin/dss_search?v=poss2ukstu_red&r=10+21+12&d=-12+23+34&e=J2000&h=20.0&w=40.0&f=gif&c=none&fov=NONE&v3=";    
    

    
    start_oneshot: function(e) {
        console.log("Starting single exposure");
        this.model.save({oneshot: true},
                        {
                            wait: true,
                            patch:true
                        }).catch(function(e) {
                            alert('Unable to start single exposure');
                        });
        console.log("Done starting single exposure");
    },

    start_continuous: function(e) {
        console.log("Starting continuous exposures");

//        var $btnStart = $(e.target),
//            $btnOneshot = $('.btn-start-oneshot').attr('disabled', true);

        this.model.save({start_exposures: true},
                        {
                            wait: true,
                            patch:true
                        }).catch(function(e) {
                            alert('Unable to start exposures');
                        });
        console.log("Done starting multiple exposures");
    },
    
    stop_continuous: function(e) {
        console.log("Stopping continuous exposures");

//        var $btnStop = $(e.target),
//            $btnOneshot = $('.btn-start-oneshot').attr('enabled', true);

        this.model.save({stopping: true},
                        {
                            wait: true,
                            patch:true
                        }).catch(function(e) {
                            alert('Unable to stop exposures');
                        });
        console.log("Done stopping multiple exposures");
    },
    

    initialize: function(guider_state) {
        this.model = new APP.GUIDER.Model(guider_state);
        
        this.model.on('load', function(model) { // does this do anything????
            console.log('Initialising page after load');
	});


	//============== start every thing with initial states======================
	
	// on startup of the webpage
	if (parseInt(guider_state.ext_continuous) == 0) { 
//	    document.getElementById("ext-continuous").style.backgroundColor = "green";
	    document.getElementById("btn-start").style.backgroundColor = "green";
	} else {
//	    document.getElementById("ext-continuous").style.backgroundColor = "red";
	    document.getElementById("btn-start").style.backgroundColor = "red";
	}
	if (parseInt(guider_state.guide_flag) == 1) { 
//	    document.getElementById("ActualGuideState").style.backgroundColor = "green";
	    document.getElementById("btn-guide").style.backgroundColor = "green";
	    document.getElementById('favicon').setAttribute('href','/static/img/green.jpg')  //
	} else {
//	    document.getElementById("ActualGuideState").style.backgroundColor = "red";
	    document.getElementById("btn-guide").style.backgroundColor = "red";
	    document.getElementById('favicon').setAttribute('href','/static/img/red.jpg')
	}
	if (parseInt(guider_state.slide_error) == 1) { 
	    document.getElementById("slide-Err").style.backgroundColor = "red";
	} else {
	    document.getElementById("slide-Err").style.backgroundColor = "black";
	}
	if (parseInt(guider_state.no_lodestars) != 2) { 
	    document.getElementById("No-lodestars").style.backgroundColor = "blue";
	} else {
	    document.getElementById("No-lodestars").style.backgroundColor = "green";
	}

	global_xc0 = guider_state.xc0; // read these into global variables for plotting on canvas in index.html
	global_yc0 = guider_state.yc0;

    



	//	global_xc = guider_state.xc; // read these into global variables for plotting on canvas in index.html
//	global_yc = guider_state.yc;





        this.model.on('change:slide_moving', function(model, position) {
            $('#slide-moving .badge').text(position);
        });

        this.model.on('change:slide_error', function(model, position) {
            $('#slide-Err .badge').text(position);
	    var value = parseInt(position);
	    if (value == 0) { 
		document.getElementById("slide-Err").style.backgroundColor = "black";
	    } else {
		document.getElementById("slide-Err").style.backgroundColor = "red";
	    }
        });

	this.model.on('change:slide_x_err_code', function(model, position) {
            $('#slide-Err_x .badge').text(position);
        });

	this.model.on('change:slide_y_err_code', function(model, position) {
            $('#slide-Err_y .badge').text(position);
        });
	
	this.model.on('change:no_lodestars', function(model, position) {
            $('#No-lodestars .badge').text(position);
	    var value = parseInt(position);
	    if (value == 2) { 
		document.getElementById("No-lodestars").style.backgroundColor = "blue";
	    } else {
		document.getElementById("No-lodestars").style.backgroundColor = "red";
	    }
        });


	this.model.on('change:slide_init', function(model, position) {
            $('#slide-init .badge').text(position);
        });

	this.model.on('change:which_slide', function(model, position) {
            $('#slide-which .badge').text(position);
        });
	
	this.model.on('change:slide_x', function(model, position) {
            $('#x-position .badge').text(position);
        });

        this.model.on('change:slide_y', function(model, position) {
            $('#y-position .badge').text(position);
        });

        this.model.on('change:exptime', function(model, position) {
            $('#ActualExpTime .badge').text(position);
	});

	this.model.on('change:binning', function(model, position) {
            $('#ActualBinning .badge').text(position);
        });

	this.model.on('change:ext_continuous', function(model, position) {
            $('#ext-continuous .badge').text(position);
	    var value = parseInt(position);
	    if (value == 0) { 
//		document.getElementById("ext-continuous").style.backgroundColor = "green";
		document.getElementById("btn-start").style.backgroundColor = "green";
	    } else {
//		document.getElementById("ext-continuous").style.backgroundColor = "red";
		document.getElementById("btn-start").style.backgroundColor = "red";
	    }
	});


	
	this.model.on('change:guide_flag', function(model, position) {
            $('#ActualGuideState .badge').text(position);
	    var value = parseInt(position);
	    if (value == 1) { // cant get this color part to work
//		document.getElementById("ActualGuideState").style.backgroundColor = "green";
		document.getElementById("btn-guide").style.backgroundColor = "green";
		document.getElementById('favicon').setAttribute('href','/static/img/green.jpg')  // href="/static/img/green.jpg"
	    } else {
//		document.getElementById("ActualGuideState").style.backgroundColor = "red";
		document.getElementById("btn-guide").style.backgroundColor = "red";
		document.getElementById('favicon').setAttribute('href','/static/img/red.jpg')  // href="/static/img/red.jpg"
	    }

        });

	this.model.on('change:message', function(model, position) {
            $('#Guider-message .badge').text(position);
        });


	this.model.on('change:xc0', function(model, position) {
            $('#Actualxc0 .badge').text(position);
	    global_xc0 = model.get("xc0"); // read these into global variables for plotting on canvas in index.html
	    global_yc0 = model.get("yc0");
//	    global_xc0 = global_xc0 - 6;
//	    global_yc0 = global_yc0 + 6;
        });

	this.model.on('change:yc0', function(model, position) {
            $('#Actualyc0 .badge').text(position);
	    global_xc0 = model.get("xc0"); // read these into global variables for plotting on canvas in index.html
	    global_yc0 = model.get("yc0");
//	    global_xc0 = global_xc0 - 6;
//	    global_yc0 = global_yc0 + 6;
        });

	this.model.on('change:xc', function(model, position) {
            $('#Actualxc .badge').text(position);
//	    var canvas = document.getElementById('canvas');
//	    var ctx = canvas.getContext("2d");
//	    global_xc = model.get("xc"); // read these into global variables for plotting on canvas in index.html
//	    global_yc = model.get("yc"); // actually xc and yc is extracted from image pixel values 0 and 1
//	    ctx.font = "20px Georgia";
//	    ctx.fillStyle = "blue";
//	    ctx.fillText("O", global_xc, global_yc);
        });
	
	this.model.on('change:yc', function(model, position) {
            $('#Actualyc .badge').text(position);
//	    var canvas = document.getElementById('canvas');
//	    var ctx = canvas.getContext("2d");
//	    global_xc = model.get("xc");
//	    global_yc = model.get("yc");
//	    ctx.font = "20px Georgia";
//	    ctx.fillStyle = "blue";
//	    ctx.fillText("O", global_xc, global_yc);
        });
	
        // Start polling the instrument state every second and attempt to retry
        // failed requests up to 5 times.
        this.model.poll(5);
    }
});
