from io import StringIO
from io import BytesIO
from http.client import BAD_REQUEST
from flask import Blueprint, jsonify, render_template, redirect, request, url_for
from flask_login import current_user, login_required
from flask_socketio import emit
from app import socketio, guider
from app.forms import Form

main = Blueprint('main', __name__)

@main.route('/', methods=['GET'])
def index():
    state = guider.state
    print("Got state = ", state)
    if (state is None or "message" not in state
        or ("Error getting state" in state['message'])):
        return render_template('index.html', state={'message': "Error getting state"})
#    form = Form(**guider.state)
    form = Form()
#    print("Rendering index")
#    return render_template('index.html', form=form, state=guider.state)

    print("In view - got guider state = ", state)
#    form = Form(**state)
    
    form.slides.data = int(state['which_slide'])
#    if int(state['slide_init']) > 0:
#        form.slide_initialised.data = 'Slide is initialised'
#    else:
#        form.slide_initialised.data = 'Slide is NOT initialised'
    form.slide_moving.data = float(state['slide_moving'])
    form.slide_init.data = float(state['slide_init'])
    form.slide_x.data = float(state['slide_x'])
    form.slide_y.data = float(state['slide_y'])
    form.binning.data= int(state['binning'])
    form.exposure_time.data = float(state['exptime']) 
    form.goto_x_coord.data= int(state['slide_x'])
    form.goto_y_coord.data= int(state['slide_y'])
    form.goto_xGS.data= int(300)
    form.goto_yGS.data= int(400)
    form.goto_RA_coord.data= "05 12 19"
    form.goto_Dec_coord.data= "-55 43 23"
    form.click_xc0.data = int(100) # set initial value to actual number to prevent crash of backend
    form.click_yc0.data = int(100) # set initial value to actual number to prevent crash of backend
    form.xc.data = float(state['xc']) # float number because center of star is sub-pixel
    form.yc.data = float(state['yc'])# float number because center of star is sub-pixel
    form.exit_continuous.data = float(state['ext_continuous'])
#    form.no_lodestars.data = float(state['no_lodestars'])
    
    print("Set exptime default to ", state['exptime'])
    return render_template('index.html', form=form, state=state)

api = Blueprint('api', __name__)

@api.route('/guider', methods=['GET'])
def get():
    return jsonify(guider.state)


@api.route('/guider', methods=['PATCH'])
def patch():
    print("In patch")
    if not request.json:
        return jsonify(), BAD_REQUEST

    for key, value in request.json.items():
        print("Setting attribute {}:{} in view".format(key, value))
        setattr(guider, key, value)

    return jsonify(guider.state)
# def patch():
#     print("In patch route")
#     if request.json.get('initialised') == True:
#         print("Received request to initialise slides")
#         guider.guider.initialise_slides()
#         print("Guider request to initialise slides has returned")
#     elif request.json.get('gclick') == True:
#         x = request.json.get('x')
#         y = request.json.get('y')
#         guider.guider.send_guide_coords(x,y)
#     print("Returning from patch route")
#     return jsonify(guider.state)


@socketio.on('connect')
def on_connect():
    print("Web client socket connected to web server socket")
    # # Try sending the data immediately
    # # Fetch an image from the camera.
    # image = guider.guider.get_image()
    # # Send the image over the websocket.
    # f = BytesIO()
    # f.write(image)
    # #    emit(u'data', f.getvalue())
    # emit(u'data', image)
    # del image, f
    # print("Data sent after initial connection")

@socketio.on('data')
def on_data():
    print("Got data request")
    # Fetch an image from the camera.
    image, p1, p2 = guider.guider.get_image()
    #print("views p1 and p2 = ", p1, p2)
    #print("views image[200:205] = ", image[200:205])
    # Send the image over the websocket.
    #    f = BytesIO()
    #    f.write(image)
    # Create a bytearray with the coordinates then the image data
    #ba = bytearray()
    #ba.extend(p1.to_bytes(2, 'big'))
    #ba.extend(p2.to_bytes(2, 'big'))
    #ba.extend(image)
    #emit('data', ba)
    #print("Emitting p1 = {}  p2 = {}  image".format(p1, p2))
    st = {'p1': p1, 'p2': p2, 'image': image}
    emit('data', st)
    #emit('data', image)
    del image, f
    print("Data sent after data request")
    print('*******************************')

@socketio.on_error_default  # handles all namespaces without an explicit error handler
def default_error_handler(e):
    pass
